Subject: Re: [PATCH net-next v2] net: Add table id from route lookup to route response

From: David Ahern <[email-masked]>
Date: Wed, 2 Sep 2015 14:47:08 -0600

On 9/2/15 2:41 PM, Alexander Duyck wrote:
>
> Why not implement this this same for IPv4 and IPv6?  It looks like it is
> only included if it is non-zer and not MAIN in the above case, and then
> below as long as a table ID is non-zero you are setting the value.  Why
> not just include the value in all cases where it is defined just like
> for IPv6?
>

I like Thomas' suggestion to add an rtm_flag better. We only need to fix 
IPv4 which hardcodes the tableid. Adding a flag, e.g.,

+#define RTM_F_LOOKUP_TABLE     0x1000  /* set rtm_table to FIB lookup 
result */

signifies the caller wants the real table. When set rt_fill_info sets 
rtm_table to the actual table id. This allows updated tools to work 
properly for both ipv4 and ipv6 and without breaking existing userspace.